nova unit tests failing in the gate with "TypeError: acquire() got an unexpected keyword argument 'delay'"

Bug #1398624 reported by Matt Riedemann on 2014-12-03
22
This bug affects 5 people
Affects Status Importance Assigned to Milestone
OpenStack Compute (nova)
High
Ben Nemec

Bug Description

http://logs.openstack.org/46/97946/25/check/gate-nova-python27/3e09cf2/console.html#_2014-12-02_23_31_22_548

2014-12-02 23:31:22.547 | 542 11641 TRACE nov{1} nova.tests.unit.virt.libvirt.test_firewall.IptablesFirewallTestCase.test_multinic_iptables [0.043933s] ... FAILED
2014-12-02 23:31:22.547 |
2014-12-02 23:31:22.547 | Captured traceback:
2014-12-02 23:31:22.547 | ~~~~~~~~~~~~~~~~~~~
2014-12-02 23:31:22.547 | Traceback (most recent call last):
2014-12-02 23:31:22.547 | File "/home/jenkins/workspace/gate-nova-python27/.tox/py27/local/lib/python2.7/site-packages/mock.py", line 1201, in patched
2014-12-02 23:31:22.547 | return func(*args, **keywargs)
2014-12-02 23:31:22.547 | File "nova/tests/unit/virt/libvirt/test_firewall.py", line 379, in test_multinic_iptables
2014-12-02 23:31:22.547 | self.fw.prepare_instance_filter(instance_ref, network_info)
2014-12-02 23:31:22.548 | File "nova/virt/firewall.py", line 183, in prepare_instance_filter
2014-12-02 23:31:22.548 | self.refresh_provider_fw_rules()
2014-12-02 23:31:22.548 | File "nova/virt/firewall.py", line 473, in refresh_provider_fw_rules
2014-12-02 23:31:22.548 | self._do_refresh_provider_fw_rules()
2014-12-02 23:31:22.548 | File "/home/jenkins/workspace/gate-nova-python27/.tox/py27/local/lib/python2.7/site-packages/oslo_concurrency/lockutils.py", line 425, in inner
2014-12-02 23:31:22.548 | do_log=False, semaphores=semaphores, delay=delay):
2014-12-02 23:31:22.548 | File "/usr/lib/python2.7/contextlib.py", line 17, in __enter__
2014-12-02 23:31:22.548 | return self.gen.next()
2014-12-02 23:31:22.548 | File "/home/jenkins/workspace/gate-nova-python27/.tox/py27/local/lib/python2.7/site-packages/oslo_concurrency/lockutils.py", line 381, in lock
2014-12-02 23:31:22.548 | ext_lock.acquire(delay=delay)
2014-12-02 23:31:22.548 | TypeError: acquire() got an unexpected keyword argument 'delay'
2014-12-02 23:31:22.549 | Traceback (most recent call last):
2014-12-02 23:31:22.549 | _StringException: Empty attachments:
2014-12-02 23:31:22.549 | stderr
2014-12-02 23:31:22.549 | stdout

1299 hits in the last 48 hours due to the oslo.concurrency 0.3.0 release today.

http://logstash.openstack.org/#eyJzZWFyY2giOiJtZXNzYWdlOlwiVHlwZUVycm9yOiBhY3F1aXJlKCkgZ290IGFuIHVuZXhwZWN0ZWQga2V5d29yZCBhcmd1bWVudCAnZGVsYXknXCIgQU5EIHRhZ3M6XCJjb25zb2xlXCIgQU5EIGJ1aWxkX25hbWU6XCJnYXRlLW5vdmEtcHl0aG9uMjdcIiIsImZpZWxkcyI6W10sIm9mZnNldCI6MCwidGltZWZyYW1lIjoiMTcyODAwIiwiZ3JhcGhtb2RlIjoiY291bnQiLCJ0aW1lIjp7InVzZXJfaW50ZXJ2YWwiOjB9LCJzdGFtcCI6MTQxNzU2NTUyMTU5OCwibW9kZSI6IiIsImFuYWx5emVfZmllbGQiOiIifQ==

Matt Riedemann (mriedem) wrote :

This was the oslo.concurrency change:

https://github.com/openstack/oslo.concurrency/commit/46c836ee28aff5bfa57598971cd175a0be0951d9

Looks like the bug is that the nova unit test is mocking out the internals of lockutils:

http://git.openstack.org/cgit/openstack/nova/tree/nova/tests/unit/virt/libvirt/test_firewall.py#n359

I don't know why that's necessary, but it's wrong now since the external_lock internals of lockutils require the lock object type extends the private _FileLock object.

Changed in oslo.concurrency:
status: New → Invalid
Changed in nova:
status: New → Triaged
Matt Riedemann (mriedem) wrote :

test_attach_interface_get_config in nova.tests.unit.virt.libvirt.test_driver also does it.

tags: added: libvirt testing
Changed in nova:
importance: Undecided → High
Matt Riedemann (mriedem) on 2014-12-03
no longer affects: oslo.concurrency

Fix proposed to branch: master
Review: https://review.openstack.org/138592

Changed in nova:
assignee: nobody → Davanum Srinivas (DIMS) (dims-v)
status: Triaged → In Progress

Change abandoned by Sean Dague (<email address hidden>) on branch: master
Review: https://review.openstack.org/138592

Matt Riedemann (mriedem) wrote :

Supposed to be fixed with https://review.openstack.org/#/c/138463/ .

Changed in nova:
status: In Progress → Fix Committed
assignee: Davanum Srinivas (DIMS) (dims-v) → Ben Nemec (bnemec)
Thierry Carrez (ttx) on 2014-12-18
Changed in nova:
milestone: none → kilo-1
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2015-04-30
Changed in nova:
milestone: kilo-1 → 2015.1.0
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers